<?php
if ( ! class_exists( 'Construction_Contractor_Plugin_Activation_WPElemento_Importer' ) ) {
    /**
     * Construction_Contractor_Plugin_Activation_WPElemento_Importer initial setup
     *
     * @since 1.6.2
     */

    class Construction_Contractor_Plugin_Activation_WPElemento_Importer {

        private static $construction_contractor_instance;
        public $construction_contractor_action_count;
        public $construction_contractor_recommended_actions;

        /** Initiator **/
        public static function get_instance() {
          if ( ! isset( self::$construction_contractor_instance) ) {
            self::$construction_contractor_instance = new self();
          }
          return self::$construction_contractor_instance;
        }

        /*  Constructor */
        public function __construct() {

            add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );

            // ---------- wpelementoimpoter Plugin Activation -------
            add_filter( 'construction_contractor_recommended_plugins', array($this, 'construction_contractor_recommended_elemento_importer_plugins_array') );

            $construction_contractor_actions                   = $this->construction_contractor_get_recommended_actions();
            $this->construction_contractor_action_count        = $construction_contractor_actions['count'];
            $this->construction_contractor_recommended_actions = $construction_contractor_actions['actions'];

            add_action( 'wp_ajax_create_pattern_setup_builder', array( $this, 'create_pattern_setup_builder' ) );
        }

        public function construction_contractor_recommended_elemento_importer_plugins_array($construction_contractor_plugins){
            $construction_contractor_plugins[] = array(
                    'name'     => esc_html__('WPElemento Importer', 'construction-contractor'),
                    'slug'     =>  'wpelemento-importer',
                    'function' => 'WPElemento_Importer_ThemeWhizzie',
                    'desc'     => esc_html__('We highly recommend installing the WPElemento Importer plugin for importing the demo content with Elementor.', 'construction-contractor'),               
            );
            return $construction_contractor_plugins;
        }

        public function enqueue_scripts() {
            wp_enqueue_script('updates');      
            wp_register_script( 'construction-contractor-plugin-activation-script', esc_url(get_template_directory_uri()) . '/includes/getstart/js/plugin-activation.js', array('jquery') );
            wp_localize_script('construction-contractor-plugin-activation-script', 'construction_contractor_plugin_activate_plugin',
                array(
                    'installing' => esc_html__('Installing', 'construction-contractor'),
                    'activating' => esc_html__('Activating', 'construction-contractor'),
                    'error' => esc_html__('Error', 'construction-contractor'),
                    'ajax_url' => esc_url(admin_url('admin-ajax.php')),
                    'wpelementoimpoter_admin_url' => esc_url(admin_url('admin.php?page=wpelemento-importer-tgmpa-install-plugins')),
                    'addon_admin_url' => esc_url(admin_url('admin.php?page=wpelementoimporter-wizard'))
                )
            );
            wp_enqueue_script( 'construction-contractor-plugin-activation-script' );

        }

        // --------- Plugin Actions ---------
        public function construction_contractor_get_recommended_actions() {

            $construction_contractor_act_count  = 0;
            $construction_contractor_actions_todo = get_option( 'recommending_actions', array());

            $construction_contractor_plugins = $this->construction_contractor_get_recommended_plugins();

            if ($construction_contractor_plugins) {
                foreach ($construction_contractor_plugins as $construction_contractor_key => $construction_contractor_plugin) {
                    $construction_contractor_action = array();
                    if (!isset($construction_contractor_plugin['slug'])) {
                        continue;
                    }

                    $construction_contractor_action['id']   = 'install_' . $construction_contractor_plugin['slug'];
                    $construction_contractor_action['desc'] = '';
                    if (isset($construction_contractor_plugin['desc'])) {
                        $construction_contractor_action['desc'] = $construction_contractor_plugin['desc'];
                    }

                    $construction_contractor_action['name'] = '';
                    if (isset($construction_contractor_plugin['name'])) {
                        $construction_contractor_action['title'] = $construction_contractor_plugin['name'];
                    }

                    $construction_contractor_link_and_is_done  = $this->construction_contractor_get_plugin_buttion($construction_contractor_plugin['slug'], $construction_contractor_plugin['name'], $construction_contractor_plugin['function']);
                    $construction_contractor_action['link']    = $construction_contractor_link_and_is_done['button'];
                    $construction_contractor_action['is_done'] = $construction_contractor_link_and_is_done['done'];
                    if (!$construction_contractor_action['is_done'] && (!isset($construction_contractor_actions_todo[$construction_contractor_action['id']]) || !$construction_contractor_actions_todo[$construction_contractor_action['id']])) {
                        $construction_contractor_act_count++;
                    }
                    $construction_contractor_recommended_actions[] = $construction_contractor_action;
                    $construction_contractor_actions_todo[]        = array('id' => $construction_contractor_action['id'], 'watch' => true);
                }
                return array('count' => $construction_contractor_act_count, 'actions' => $construction_contractor_recommended_actions);
            }

        }

        public function construction_contractor_get_recommended_plugins() {

            $construction_contractor_plugins = apply_filters('construction_contractor_recommended_plugins', array());
            return $construction_contractor_plugins;
        }

        public function construction_contractor_get_plugin_buttion($slug, $name, $function) {
                $construction_contractor_is_done      = false;
                $construction_contractor_button_html  = '';
                $construction_contractor_is_installed = $this->is_plugin_installed($slug);
                $construction_contractor_plugin_path  = $this->get_plugin_basename_from_slug($slug);
                $construction_contractor_is_activeted = (class_exists($function)) ? true : false;
                if (!$construction_contractor_is_installed) {
                    $construction_contractor_plugin_install_url = add_query_arg(
                        array(
                            'action' => 'install-plugin',
                            'plugin' => $slug,
                        ),
                        self_admin_url('update.php')
                    );
                    $construction_contractor_plugin_install_url = wp_nonce_url($construction_contractor_plugin_install_url, 'install-plugin_' . esc_attr($slug));
                    $construction_contractor_button_html        = sprintf('<a class="construction-contractor-plugin-install install-now button-secondary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($construction_contractor_plugin_install_url),
                        sprintf(esc_html__('Install %s Now', 'construction-contractor'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Install & Activate', 'construction-contractor')
                    );
                } elseif ($construction_contractor_is_installed && !$construction_contractor_is_activeted) {

                    $construction_contractor_plugin_activate_link = add_query_arg(
                        array(
                            'action'        => 'activate',
                            'plugin'        => rawurlencode($construction_contractor_plugin_path),
                            'plugin_status' => 'all',
                            'paged'         => '1',
                            '_wpnonce'      => wp_create_nonce('activate-plugin_' . $construction_contractor_plugin_path),
                        ), self_admin_url('plugins.php')
                    );

                    $construction_contractor_button_html = sprintf('<a class="construction-contractor-plugin-activate activate-now button-primary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($construction_contractor_plugin_activate_link),
                        sprintf(esc_html__('Activate %s Now', 'construction-contractor'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Activate', 'construction-contractor')
                    );
                } elseif ($construction_contractor_is_activeted) {
                    $construction_contractor_button_html = sprintf('<div class="action-link button disabled"><span class="dashicons dashicons-yes"></span> %s</div>', esc_html__('Active', 'construction-contractor'));
                    $construction_contractor_is_done     = true;
                }

                return array('done' => $construction_contractor_is_done, 'button' => $construction_contractor_button_html);
            }
        public function is_plugin_installed($slug) {
            $construction_contractor_installed_plugins = $this->get_installed_plugins(); // Retrieve a list of all installed plugins (WP cached).
            $construction_contractor_file_path         = $this->get_plugin_basename_from_slug($slug);
            return (!empty($construction_contractor_installed_plugins[$construction_contractor_file_path]));
        }
        public function get_plugin_basename_from_slug($slug) {
            $construction_contractor_keys = array_keys($this->get_installed_plugins());
            foreach ($construction_contractor_keys as $construction_contractor_key) {
                if (preg_match('|^' . $slug . '/|', $construction_contractor_key)) {
                    return $construction_contractor_key;
                }
            }
            return $slug;
        }

        public function get_installed_plugins() {

            if (!function_exists('get_plugins')) {
                require_once ABSPATH . 'wp-admin/includes/plugin.php';
            }

            return get_plugins();
        }
        public function create_pattern_setup_builder() {

            $edit_page = admin_url().'post-new.php?post_type=page&create_pattern=true';
            echo json_encode(['page_id'=>'','edit_page_url'=> $edit_page ]);

            exit;
        }

    }
}
/**
 * Kicking this off by calling 'get_instance()' method
 */
Construction_Contractor_Plugin_Activation_WPElemento_Importer::get_instance();